package modele

class DashBoard(private val width: Int,private val height: Int) {
    private val gridOfGame = Array(this.height){IntArray(this.width)}

    // Our getter
    fun getWidth(): Int = this.width
    fun getHeight(): Int = this.height

    // To set something to occupied

    fun toOccupied(col: Int,row: Int){
        gridOfGame[row][col] = 1
    }

    // To check if an position is occupied
    fun isOccupied(col: Int,row: Int): Boolean = gridOfGame[row][col] != 0

    fun isLineFull(row: Int): Boolean{
        for (col in 0 until this.width){
            if(gridOfGame[row][col] == 0){
                return false
            }
        }
        return true
    }

    fun clearLine(row: Int){
        for (col in 0 until this.width){
            gridOfGame[row][col] = 0
        }
    }

    fun shiftDown(rowToBegin: Int){
        for (row in (height - 1)..rowToBegin){
            for (col in 0 until this.width){
                gridOfGame[row][col] = gridOfGame[row - rowToBegin][col]
            }
        }
        for (row in 0 until rowToBegin){
            for (col in 0 until this.width){
                gridOfGame[row][col] = 0
            }
        }
    }

    //To check each grid line and remove if a line is full. Uses clearLine(), isLineFull() and shiftDown()
    fun clearLines(){
        var nbRowCleared: Int = 0
        for (row in 0 until this.height){
            if(isLineFull(row)){
                clearLine(row)
                ++nbRowCleared
            }
        }
        if(nbRowCleared != 0){
            shiftDown(nbRowCleared)
        }
    }
}