package modele

import java.lang.reflect.Type
import kotlin.random.Random

class TypeShape(private val type: EnumTypeShape,private val showShape: Array<Array<Array<Int>>>){

    private var currentIndex = 0

    fun getPoints(): Array<Position>{
        val positions = ArrayList<Position>()
        val typeShape = getCurrentType()
        for (i in typeShape.indices){
            for (j in typeShape[i].indices){
                if (typeShape[i][j] != 0) {
                    positions.add(Position(j, i))
                }
            }
        }
        return positions.toTypedArray()
    }

    //to augmente of 1 the current index
    fun getNextType(): TypeShape {
        currentIndex++
        return this
    }

    //To get the next shape
    fun getNextShape(){
        val random: Int = Random.nextInt(1,7)
        when(random){
            1 -> TypeShape(EnumTypeShape.IShape, arrayOf(arrayOf(arrayOf())))
            2 -> TypeShape(EnumTypeShape.SquareShape, arrayOf(arrayOf(arrayOf())))
            3 -> TypeShape(EnumTypeShape.JShape, arrayOf(arrayOf(arrayOf())))
            4 -> TypeShape(EnumTypeShape.LShape, arrayOf(arrayOf(arrayOf())))
            5 -> TypeShape(EnumTypeShape.SShape, arrayOf(arrayOf(arrayOf())))
            6 -> TypeShape(EnumTypeShape.TShape, arrayOf(arrayOf(arrayOf())))
            7 -> TypeShape(EnumTypeShape.ZShape, arrayOf(arrayOf(arrayOf())))
            else -> throw Exception("Problème de random getNextShape()")
        }
    }

    // To get the table of position of the current shape type
    private fun getCurrentType(): Array<Array<Int>> {
        return showShape[currentIndex]
    }
}